package org.sistema.hibernate.tableperconcreteclassannotations;

import org.sistema.hibernate.tableperconcreteclassannotations.dao.GenericDAO;
import org.sistema.hibernate.tableperconcreteclassannotations.models.Course;
import org.sistema.hibernate.tableperconcreteclassannotations.models.Dessert;
import org.sistema.hibernate.tableperconcreteclassannotations.models.Drink;
import org.sistema.hibernate.tableperconcreteclassannotations.models.Food;
import org.sistema.hibernate.tableperconcreteclassannotations.models.Product;

/**
 * Main class to try some operations
 * @author Eugenia Pérez Martínez
 * @email eugenia_perez@cuatrovientos.org
 */
public class Main {

	public static void main(String[] args) {
		Drink drink = new Drink("Coke", 3.5f, true);
		Food food = new Food("Salad", 14.0f, "Special Salad");
		Course course1 = new Course("Pasta", 16.49f,"Ravioli", "starter");
		Course course2 = new Course("Steak", 29.99f,"Raw meat", "Second course");
		Dessert dessert = new Dessert("Cheesecake", 5.99f,"Special cheesecake", 500.0f);


		new GenericDAO<Drink>().insert(drink);
		new GenericDAO<Food>().insert(food);
		new GenericDAO<Dessert>().insert(dessert);
		GenericDAO<Course> genericDAO = new GenericDAO<Course>();
		genericDAO.insert(course1);
		genericDAO.insert(course2);
		
		genericDAO.selectById(course1.getId(), Course.class);
		new GenericDAO<Product>().selectById(course1.getId(), Product.class);
	}

}
